package Semantic_Description;

import java.awt.BorderLayout;
import java.awt.Color;   
import java.awt.Component;   
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Collections;   
import java.util.HashSet;   
import java.util.Iterator;   
import java.util.Set;   
   
import javax.swing.JButton;
import javax.swing.JFrame;   
import javax.swing.JPanel;
import javax.swing.JScrollPane;   
import javax.swing.JTextField;
import javax.swing.JTree;   
import javax.swing.WindowConstants;   
import javax.swing.event.TreeModelEvent;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.tree.DefaultMutableTreeNode;   
import javax.swing.tree.DefaultTreeCellRenderer;   
import javax.swing.tree.DefaultTreeModel;   
import javax.swing.tree.TreeCellRenderer;   
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;
   
import org.mindswap.pellet.jena.PelletInfGraph;   
import org.mindswap.pellet.jena.PelletReasonerFactory;   
   
import com.hp.hpl.jena.ontology.OntClass;   
import com.hp.hpl.jena.ontology.OntModel;   
import com.hp.hpl.jena.ontology.OntResource;   
import com.hp.hpl.jena.rdf.model.ModelFactory;   
import com.hp.hpl.jena.vocabulary.OWL;
import javax.swing.JTextArea;   
   
/**  
 * An example to show how to use OWLReasoner class. This example creates a JTree that displays the  
 * class hierarchy. This is a simplified version of the class tree displayed in SWOOP.  
 *   
 * usage: java ClassTree <ontology URI>  
 *   
 * @author Evren Sirin  
 */  
public class ClassTree_new2  {   
    OntModel model;   
    JTree classTree;
    Set unsatConcepts;   
    private static javax.swing.JTextField commentaire;
    JPanel panel = new JPanel();
    String name_node;
    String select_node;
    //------------------------- Pour crire dans un fichier -----------------------------
	FileOutputStream fos;
	PrintStream myOutput;
    //------------------------------------------ Valeur pour annotation ----------------------------------
    String value_annotation;
    final JTextField textField_comm = new JTextField();
    
    TreeCellRenderer treeCellRenderer = new DefaultTreeCellRenderer() {   
        public Component getTreeCellRendererComponent( JTree tree, Object value, boolean sel,   
                                                      boolean expanded, boolean leaf, int row,   
                                                      boolean hasFocus ) {   
            super.getTreeCellRendererComponent( tree, value, sel, expanded, leaf, row, hasFocus );   
   
            DefaultMutableTreeNode node = (DefaultMutableTreeNode) value;   
   
            // each node represents a set of classes   
            Set set = (Set) node.getUserObject();   
            String label = "";   
   
            // a set may contain one or more elements   
            if( set.size() > 1 )   
                label += "[";   
            Iterator i = set.iterator();   
   
            // get the first one and add it to the label   
            OntResource first = (OntResource) i.next();   
            label += model.shortForm( first.getURI() );   
            // add the rest (if they exist)   
            while( i.hasNext() ) {   
                OntResource c = (OntResource) i.next();   
   
                label += " = ";   
                label += model.shortForm( c.getURI() );   
            }   
            if( set.size() > 1 )   
                label += "]";   
   
            // show unsatisfiable concepts red   
            if( unsatConcepts.contains( first ) ) {   
                setForeground( Color.RED );   
            }   
   
            setText( label );   
            setIcon( getDefaultClosedIcon() );   
           
            return this;   
        }   
      
    };   
     
     
    public ClassTree_new2( String ontology ) throws Exception {
    	 // create a reasoner   
        model = ModelFactory.createOntologyModel( PelletReasonerFactory.THE_SPEC );   
   
        // create a model for the ontology   
        System.out.print( "Reading..." );   
        model.read( ontology );   
        System.out.println( "done" );   
   
        // load the model to the reasoner   
        System.out.print( "Preparing..." );   
        model.prepare();   
        System.out.println( "done" );   
   
        // compute the classification tree   
        System.out.print( "Classifying..." );   
        ((PelletInfGraph) model.getGraph()).getKB().classify();   
        System.out.println( "done" );   
     //%%%   getContentPane().add( new JScrollPane( getJTree() ) );   
        JPanel panel = new JPanel();

    	}   
    //-------
	void tree1_mouseClicked(MouseEvent e)
	{    System.out.println("================Entre dans tree1_mouseClicked=================");
		int click_val=1;
	 	DefaultMutableTreeNode node;
		String elt="";//elt du jtree clicked
		node = (DefaultMutableTreeNode)classTree.getLastSelectedPathComponent();
	
			if((e.getClickCount() == 2 )&& (node.isLeaf()))
   	        {       
				    elt=node.toString();
				    setSelect_node(elt);
				    System.out.println("eltttttttttttttttttttttttttttt====="+elt);
				    System.out.println("==========999= this.getSelect_node() =========="+this.getSelect_node());
		    }
	}
  //---------------------------------------------------------------------------------------  
    public Set collect( Iterator i ) {   
        Set set = new HashSet();   
        while( i.hasNext() ) {   
            OntResource res = (OntResource) i.next();   
            
            System.out.println("------------");   
            System.out.print(res.getLocalName()+ "  : ");   
            for (Iterator iter = res.listProperties(); iter.hasNext(); ) { //.listProperties()   
                System.out.println(" ||  "+iter.next()+" |* ");  ///((OntProperty)iter.next()).getLocalName()   
                   
                }   
   
            System.out.println("------------");   
              
            if( res.isAnon() )   
                continue;   
               
            set.add( res );   
        }   
       
        return set;   
    }   
   
    public JTree getJTree() {   
        // Use OntClass for convenience   
        OntClass owlThing = model.getOntClass( OWL.Thing.getURI() );   
        OntClass owlNothing = model.getOntClass( OWL.Nothing.getURI() );   
           
           
        // Find all unsatisfiable concepts, i.e classes equivalent   
        // to owl:Nothing   
        unsatConcepts = collect( owlNothing.listEquivalentClasses() );   
   
        // create a tree starting with owl:Thing node as the root   
        DefaultMutableTreeNode thing = createTree( owlThing );   
        
        Iterator i = unsatConcepts.iterator();   
        if( i.hasNext() ) {   
            // We want to display every unsatisfiable concept as a   
            // different node in the tree   
            DefaultMutableTreeNode nothing = createSingletonNode( owlNothing );   
            // iterate through unsatisfiable concepts and add them to   
            // the tree   
            while( i.hasNext() ) {   
                OntClass unsat = (OntClass) i.next();   
   
                if( unsat.equals( owlNothing ) )   
                    continue;   
                   
                DefaultMutableTreeNode node = createSingletonNode( unsat );   
                nothing.add( node );   
            }   
   
            // add nothing as a child node to owl:Thing   
            //------------------ thing.add( nothing );   --------------------------supp par Faten pour ne pas afficher: nothing
        }   
   
        // create the tree   
        classTree = new JTree( new DefaultTreeModel( thing ) );
        classTree.setCellRenderer( treeCellRenderer );   
   
        // expand everything   
        for( int r = 0; r<classTree.getRowCount(); r++ )   // "<" est fait par Faten car j'ai pas trouv d'opration, donc elle m'a donn une Erreur
            classTree.expandRow( r );   
   
        return classTree;   
    }   
   
    /**  
     * Create a root node for the given concepts and add child nodes for the subclasses. Return null  
     * for owl:Nothing  
     *   
     * @param concepts  
     * @return  
     */   
    DefaultMutableTreeNode createTree( OntClass cls ) {   
        if( unsatConcepts.contains( cls ) )   
            return null;   
   
        DefaultMutableTreeNode root = createNode( cls );   
   
        Set processedSubs = new HashSet();   
           
        // get only direct subclasses   
        Iterator subs = cls.listSubClasses( true );   
        while( subs.hasNext() ) {   
            OntClass sub = (OntClass) subs.next();   
               
            if( sub.isAnon() )   
                continue;   
   
            if( processedSubs.contains( sub ) )   
                continue;   
               
            DefaultMutableTreeNode node = createTree( sub );   
            // if set contains owl:Nothing tree will be null   
            if( node != null ) {   
                root.add( node );   
               
                processedSubs.addAll( (Set) node.getUserObject() );   
            }   
        }   
   
        return root;   
    }   
   
    /**  
     * Create a TreeNode for the given class  
     *   
     * @param entity  
     * @return  
     */   
    DefaultMutableTreeNode createSingletonNode( OntResource cls ) {   
        return new DefaultMutableTreeNode( Collections.singleton( cls ) );   
    }   
   
    /**  
     * Create a TreeNode for the given set of classes  
     *   
     * @param entity  
     * @return  
     */   
    DefaultMutableTreeNode createNode( OntClass cls ) {   
        Set eqs = collect( cls.listEquivalentClasses() );   
           
        return new DefaultMutableTreeNode( eqs );   
    }   
   //---------------------------------------- pour select elet----------------------------------
    public void treeNodesChanged(TreeModelEvent e) {
        DefaultMutableTreeNode node;
        node = (DefaultMutableTreeNode)
                 (e.getTreePath().getLastPathComponent());
      try {
            int index = e.getChildIndices()[0];
            node = (DefaultMutableTreeNode)
                   (node.getChildAt(index));
        } catch (NullPointerException exc) {}

        System.out.println("The user has finished editing the node.");
        System.out.println("New value: " + node.getUserObject());
    }
     //-----------------------Mthode pour afficher l'lement selectionn-------------------------------
     public void Affiche_elet() {
  	   DefaultMutableTreeNode selNode = (DefaultMutableTreeNode) classTree
         .getLastSelectedPathComponent();
  	   System.out.println("=======&&&&&&& selNode.toString() &&&&&&&&======= "+ selNode.toString());
    }
  	//--------------------------------------- Get & Set -------------------------------------------
  	public String getValue_annotation() {
  		return value_annotation;
  	}

  	public void setValue_annotation(String value_annotation) {
  		this.value_annotation = value_annotation;
  	}
  	
  public String getName_node() {
		return name_node;
	}

	public void setName_node(String name_node) {
		this.name_node = name_node;
	}

	
	
	public String getSelect_node() {
		return select_node;
	}
	public void setSelect_node(String select_node) {
		this.select_node = select_node;
	}
	public void affich_elet_tree() throws Exception{
	  //	ClassTree_new tree = new ClassTree_new("file:///D:/Master_faten/juillet_avec_fairouz3(faten)/TRee_annotation_de_Faten!!/vehicule2.owl"); 
    	 System.out.println("=========== this.getSelect_node() =========="+this.getSelect_node());   
	}
	//-------------------------------------------------------------------------------------------
     public static void main( String[] args ) throws Exception {      	 
    	 //*ClassTree_new2 tree = new ClassTree_new2("http://127.0.0.1/ontology/Linguistic_Resources.owl"); //Faten--Marche Finalllllllllllllll
    	    ClassTree_new2 tree = new ClassTree_new2("http://127.0.0.1/ontology/All_Domain_Ontology.owl"); //Faten--Toute Ontology
    	    System.out.println("=========== tree.getSelect_node() =========="+tree.getSelect_node());
     	
    }   
}   

 